<?php
/**
 * Created by JetBrains PhpStorm.
 * User: paulopimenta
 * Date: 08/01/13
 * Time: 16:13
 * To change this template use File | Settings | File Templates.
 */
namespace Planejamento\Logic\Cardapio\Exception;

class RestricoesCardadia extends \Planejamento\Logic\Exception
{
    private $messageName;

    public function __construct($messageName, $code = 0, \Exception $previous = null)
    {
        parent::__construct($messageName, $code, $previous);
        $this->messageName = $messageName;
    }

    public static function informeServico() {
        throw new self('pla01100_informe_servico');
    }

    public static function informeFilial(){
        throw new self('pla01100_informe_filial');
    }

    public static function informeMes(){
        throw new self('pla01100_informe_mes');
    }

    public static function mesMenorDtProcessamento(){
        throw new self('pla01100_mes_menor_dtprocessamento');
    }

    public static function pratoNaoCadastrado(){
        throw new self('pla01100_prato_nao_cadastrado');
    }

    public static function mesmoMesDtInicialDtFinal(){
        throw new self('pla06600_mesmo_Mes_DtInicial_DtFinal');
    }

    public static function pratoNaoExisteCardapioInformado(){
        throw new self('pla06600_prato_nao_existe_cardapio');
    }

    public static function impossivelTrocarPrato(){
        throw new self('pla06600_impossivel_trocar_prato');
    }

    /**
     * @param $mensagens array
     * @throws RestricoesCardadia
     */
    public static function logErro($mensagens){
        foreach ($mensagens as $mensagem)
            throw new self($mensagem);
    }

    public function getMessageName()
    {
        return $this->messageName;
    }
}